
/*
 *
 *    Title     : A78 Demo program
 *    Editor    : Davis Wang in ICP Electronic
 *    Compilier : TC 2.01
 *    OS        : DOS 6.22 or Above
 *    Execute   : C:\A78 String0 String1
 *  	          where String0 will display on LCD line 0
 *		        String1 will display on LCD line 1
 *                e.g. C:\A78 ICP Electronic
 *
 */

#include <dos.h>
#include <stdio.h>
#include <conio.h>
#define COM1   0x3f8
#define COM2   0x2f8
#define IOBASE COM1



void InitUART(void){

     outport(IOBASE+3, 0x80);    /* Line Control Register */
     outport(IOBASE+0, 0x60);    /* Divisor Latch Low     */
     outport(IOBASE+1, 0x00);    /* Divisor Latch High    */
     outport(IOBASE+3, 0x03);
}


void SendByte(char ch){

     while(!(inport(IOBASE+5) & 0x20));
     outport(IOBASE, ch);
}

char GetByte(void){

     while(!(inport(IOBASE+5) & 0x01));
     return inport(IOBASE);
}


void Clear_LCD(void){

     SendByte(0x4D);
     SendByte(0x0D);
}

void SendString(int line, char *s){
int i,j;

     i=strlen(s);
     SendByte(0x4D);
     SendByte(0x0C);
     SendByte(line);
     SendByte(i);
     for(j=0; j<i; j++)SendByte(*(s+j));
}

void main(int argc, char *argv[]){


     InitUART();
     Clear_LCD();
     switch(argc){
       case 2:
	       SendString(0, argv[1]);
	       break;
       case 3:
	       SendString(0, argv[1]);
	       SendString(1, argv[2]);
	       break;
     }
}